<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<html>
<head>
<title>Tibetan Calendar Converter</title>
<style type="text/css">
body{
  font-family: Verdana, Lucida, Geneva, Helvetica, Arial, sans-serif;
}
table.tibcal {
  font-size:11px;
}
p {
 font-size:12px;
}
caption {
  background-color:#b9b9b9;
  padding:2px 2px 2px 2px;
}
</style>
</head>
<body>
<?php
/*
  Initialize arrays for the Animals and Elements.
  These just make it convenient to display the form elements in FOR loops
  (see Display the Form, below)
*/  
  
  $animals_english = array("Hare","Dragon","Snake","Horse",
	  "Sheep","Monkey","Bird","Dog","Pig","Rat","Ox","Tiger");
  $animals_phonetic = array("y&ouml;","druk","tr&uuml;","ta",
	  "luk","tre","ja","khyi","pak","tsi","lang","tak");
  $animals_wylie = array("yos","'brug","sbrul","rta",
	  "lug","spre","bya","khyi","phag","tsi","glang","stag");

  $elements_english = array("Fire","Earth","Iron","Water","Wood");
  $elements_phonetic = array("me","sa","chak","chu","shing");
  $elements_wylie = array("me","sa","lcags","chu","zhing");

?>

  <table width="100%" border="0" cellspacing="0" cellpadding="0">
    <tr valign="top">
      <td width="25%">

<?php
/*
  Three pieces of information are received as user input: 
    ANIMAL (required)
    ELEMENT (required)
    CYCLE (optional-- if omitted, all possible rabjung cycles are displayed)
  If either ANIMAL or ELEMENT are blank, the request is malformed and just the basic 
  form is displayed.
*/
  $animal = isset($_REQUEST['animal'])? $_REQUEST['animal'] : null;
  $element = isset($_REQUEST['element'])?$_REQUEST['element'] : null;
  $cycle= isset($_REQUEST['cycle'])? $_REQUEST['cycle'] : null;

/*
  The variable '$results' will contain the form processing results, if any.
*/
  $results = '';
/*
  Both $animal and $element are required fields, so we assume if they are set then we are
  getting a request from the form and we need to process the request.
*/
  if( isset($animal) && isset($element) ) {
    // Here is the heart of the algorithm. It's quite simple.
    if( ((2 * $element) >= $animal) && ($animal % 2 == 0) )
      $j = 1;
    else if( ((2 * $element) < $animal) && ($animal % 2 == 0) )
      $j = 61;
    else if( ((2 * $element) > $animal) && ($animal % 2 > 0) )
      $j = -5;
    else if( ($element == 0) && ($animal == 11) )
      $j = 115;
    else $j = 55;
    $year_of_cycle = (12 * $element) - (5 * $animal) + $j;

    $results .= "<h2>Results</h2>\n";
    if( isset($cycle) && ($cycle > 0) ){
      $year_ce = $year_of_cycle + (60 * $cycle) + 966;
      $results .= "The Tibetan <b>$elements_english[$element] $animals_english[$animal]</b> year of the " .
	$cycle;
      switch( $cycle ){
	case 1:  $results .= "<sup>st</sup>"; break;
	case 2:  $results .= "<sup>nd</sup>"; break;
	case 3:  $results .= "<sup>rd</sup>"; break;
	default: $results .= "<sup>th</sup>";
      }
      $results .= " Rabjung corresponds to " .
	    "<b>" . $year_ce . "-" . ($year_ce + 1) . "</b>" .
	    " of the Common Era.";
    }
    else {
      $results .= "The Tibetan <b>$elements_english[$element] $animals_english[$animal]</b> year " .
	      "corresponds to the following Common Era years:<br>\n";
      $results .= "<table border='0'>\n";
      $results .= "<tr valign='top'>\n<td>";
      for( $i=1; $i<19; ++$i ){
	      if( (($i-1) % 9) == 0 )
		      $results .= "</td>\n<td width='10'></td>\n<td>\n";
	      $year_ce = $year_of_cycle + (60 * $i) + 966;
	      $results .= "&nbsp;&nbsp;$year_ce-" . ($year_ce + 1) . " <span class='s11'>(" .
				      $i;
	      switch( $i ){
		      case 1:  $results .= "<sup>st</sup>"; break;
		      case 2:  $results .= "<sup>nd</sup>"; break;
		      case 3:  $results .= "<sup>rd</sup>"; break;
		      default: $results .= "<sup>th</sup>";
	      }
	      $results .= " Rabjung)</span><br>";
      }
      $results .= "</td>\n</tr>\n</table>\n";
    }
  }
?>
<?php 
//If there are results from the form processing, display them in a grey box.
  if( $results ) { 
?>
<div style="background-color:#b9b9b9;width:650px;padding:3px 3px 3px 3px;border:1px solid black;
	margin-bottom:5px;font-size:12px;"><?= $results ?></div>
<?php 
  } 
//Then, display the form...  
?>

<div style="clear:both;"></div>

<div style="width:660px;">
<div style="border:1px solid black;float:left;padding:3px 3px 3px 3px;width:325px;">
  Convert Tibetan calendar years into their Western (<i>Common Era</i>
  or <i>A.D.</i>) equivalents.
  <div style="clear:both;margin-bottom:6px;"></div>

<!-- Display the Form -->  
  <form action="<?=$_SERVER['PHP_SELF'] ?>">
    <table class="tibcal" border="0" cellpadding="0">
      <caption class="bold" align="left" valign="top">1. Select an Animal</caption>
      <tr><th></th><th>&nbsp;English&nbsp;</th><th>&nbsp;Tibetan&nbsp;</th>
      <th>&nbsp;Phonetic&nbsp;</th><th>&nbsp;Wylie&nbsp;</th></tr>
<?php
  for( $i=0; $i<count($animals_english); ++$i ){
    echo "<tr>\n";
    echo "	<td><input type='radio' name='animal' value='$i' ";
    if( isset($animal) ){
      if( ($animal == $i) )
	echo "checked";
    }
    else
      if( $i == 0 ) echo "checked";
    echo "></td>\n";
    echo "<td>$animals_english[$i]</td>\n";
    echo "<td align='center'><img src='tibletters/" .
      str_replace("'","_",$animals_wylie[$i]) . ".gif'></td>\n";
    echo "<td align='center'>$animals_phonetic[$i]</td>\n";
    echo "<td align='center'>$animals_wylie[$i]</td>\n";
    echo "</tr>\n";
  }
?>
  </table>
</div>

<div style="float:left;width:325px;">
<div style="border:1px solid black;padding:3px 3px 3px 3px;">
  <table class="tibcal" border="0" cellpadding="0">
    <caption class="bold" align="left" valign="top">2. Select an Element</caption>
    <th></th><th>&nbsp;English&nbsp;</th><th>&nbsp;Tibetan&nbsp;</th>
    <th>&nbsp;Phonetic&nbsp;</th><th>&nbsp;Wylie&nbsp;</th>
<?php
  for( $i=0; $i<count($elements_english); ++$i ){
    echo "<tr>\n";
    echo "	<td><input type='radio' name='element' value='$i' ";
    if( isset($element) ){
      if( ($element == $i) )
	echo "checked";
    }
    else
      if( $i == 0 ) echo "checked";
    echo "></td>\n";
    echo "<td>$elements_english[$i]</td>\n";
    echo "<td align='center'><img src='tibletters/" .
      str_replace("'","_",$elements_wylie[$i]) . ".gif'></td>\n";
    echo "<td align='center'>$elements_phonetic[$i]</td>\n";
    echo "<td align='center'>$elements_wylie[$i]</td>\n";
    echo "</tr>\n";
  }
?>
  </table>
</div>
<div style="border:1px solid black;padding:3px 3px 3px 3px;">
  <table class="tibcal" width="100%" border="0">
	  <caption class="bold" align="left" valign="top">3. Select a Rabjung Cycle</caption>
		  <tr><td>
			  <select name="cycle">
<?php
//Show rabjung cycles up to the 18th rabjung, which begins in 2047
  for( $i=0; $i<19; ++$i ){
    echo "<option value=$i ";
    if( isset($cycle) ){
      if( $cycle == $i ) echo "selected";
    }
    else if( $i==0 )
      echo "selected";
    echo ">";
    if( $i == 0 )
      echo "Unknown";
    else {
      echo "$i (" . (967 + (60*$i)) . " - " . (967 + (60*$i) + 60) . " C.E.)";
    }
    echo "</option>\n";
  }
?>
	</select>
      </td></tr>
    <caption align="left" valign="bottom">If "Unknown", a set of possible Western years will be returned.</caption>
  </table>
  <p>
  <input type="submit" value="Convert">
</div>
</div>

<div style="clear:both;"></div>
<div>
  <div style="width:500px;">
  <a name="details"></a>
  <h2>The Details</h2>
  <p>
  A Tibetan year is properly identified by three parts. The first two,
  the <b>Animal</b> and <b>Element</b>, correspond roughly to similar identifiers used in the Chinese calendar.
  The third part is the <b>Rabjung</b>
  (<i>rab byung</i>, <img src="tibletters/rab_byung.gif" alt="rab byung" hspace="0" vspace="0" align="middle">).
  The Rabjung are 60-year cycles, the first of which began in 1027 C.E.
  We are currently in the
  17th Rabjung, which began on February 28, 1987.

  <p>
  Unfortunately, pre-modern Tibetan literature doesn't always identify dates with all three of these
  parts &#151; often only the animal and element are explicitly mentioned (and sometimes not
  even these are given). However, if
  you can narrow the author's dates to within a century or so, then it's not hard to
  figure out the rabjung for yourself.

  <p>
  Each year of a Rabjung cycle spans two Western years. This is because the Tibetan New Year
  or Losar (<i>lo gsar</i>,
  <img src="tibletters/lo_gsar.gif" alt="lo gsar" hspace="0" vspace="0" align="middle">)
  falls in either February or March.
  You will find a table of Tibetan New Years from 1880 to 1997 in Philippe Cornu's
  <i><a target="_blank"
	  href="http://www.amazon.com/exec/obidos/ASIN/1570622175/qid=1021759117/sr=1-1/ref=sr_1_1/103-7871113-3823018">Tibetan Astrology</a></i>
  (Boston: Shambhala, 1997), pp. 157-170.

  <p>
  This calculator is based on an algorithm published by Peter Meyer at
  <a target="_blank" href="https://www.hermetic.ch/cal_stud/tib_year.htm">https://www.hermetic.ch/cal_stud/tib_year.htm</a>.

  <p>
  For more in-depth information about the Tibetan calendar, see 
  <a target="_blank" href="http://www.nitartha.org/calendar_overview.html">
  http://www.nitartha.org/calendar_overview.html</a>.

  </div>
</div>

</body>
</html>
